--@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
--  Page 13 - The Execution plan lies. 
--  Not really. It's just that it's based on estimates and only provides an estimate for the first interation of rCTE.
--  This section compares an rCTE to the fnTally function.
--  Execution plan says the rCTE takes 0% of the batch and the fnTally function takes 100%.
--  The actual run proves that almost the exact opposite is true (Using SQL Profiler to measure stats).
--  SETUP SQL SERVER PROFILER (or Extended Events) BEFORE RUNNING THIS CODE SO YOU CAN SEE THE DAMAGE DONE BY THE rCTE.
--@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
GO
--===== Set the environment ===========================================================================================
    SET STATISTICS TIME,IO OFF;
    SET NOCOUNT ON; --Supress the autodisplay of row counts.

--===== Clear the guns ================================================================================================
     -- DO NOT RUN THIS SECTION ON A PRODUCTION BOX!!!
        CHECKPOINT;
   DBCC FREEPROCCACHE;
   DBCC DROPCLEANBUFFERS;

--===== Drop any existing Temp Tables to make reruns in SSMS easier ===================================================
   DROP TABLE IF EXISTS
         #MyHead01
        ,#MyHead02
;
GO
--===== 1. Recursive CTE ==============================================================================================
   WITH cteTally AS
( --=== Counter rCTE counts from 0 to the number of days needed
 SELECT 1 AS N      --This provides the starting point (anchor) of zero
  UNION ALL 
 SELECT N + 1       --This is the recursive part
   FROM cteTally
  WHERE N < 1000000 
) --=== Insert the value of N into the table
 SELECT N
   INTO #MyHead01 -- SELECT * FROM #MyHead01 ORDER BY N
   FROM cteTally
  ORDER BY N
 OPTION (MAXRECURSION 0) --Needed more than the default of 100 and the max of 32,768
;
GO
--===== 2. Tally Function =============================================================================================
 SELECT t.N
   INTO #MyHead02 -- SELECT * FROM #MyHead02 ORDER BY N
   FROM dbo.GetNumsNew(1,1000000) t
  ORDER BY t.N
;
GO
--===== Test Cleanup ==================================================================================================
   DROP TABLE IF EXISTS
         #MyHead01
        ,#MyHead02
;
GO
